= How do I use ratproxy to look for security issues my web application? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://code.google.com/p/ratproxy/ Ratproxy] is a web application security audit tool. It is a passive tool, watching 
data sent to and from the browser and the web application. It does not typically send extra requests or modify data 
being sent between the web application and the user (although it can, with the `-X` and `-C` options).

== Usage ==

Log into SecureCI™ system using SSH. Then start up ratproxy using the following command:

{{{
  cd log-directory
  ratproxy -v . -w ratproxy.log -p 8282 -d 192.168.1.10 -lextifscgjm
}}}

where:

  `log-directory` is a directory to store all the request/response data and the log file. By changing to the directory first, you ensure that the trace files (from `-v`) will be accessible when viewing the report.

  `8282` is the port to listen on for connections. (Make sure you open whatever port you choose in the [HowTo/OpenPortInFirewall firewall].)

  `192.168.1.10` is the FQDN of the web application to be analyzed. Any URL that matches will be analyzed. URLs that do not match will not be logged. You may add multiple `-d` options.

  `-lextifscgjm` are the analysis options. `-lfscm` is almost a minimum. `-XClextifscgjm` is the most intrusive. The `-X` and `-C` options are not passive, and can generate extra requests to the application.

Additional options:

  `-k` to make sure all traffic is using HTTPS, no HTTP.

  `-r` to open the proxy to any remote user, not just a user on the local host. Other users can then use this ratproxy instance as their proxy.

Once the ratproxy is running, set up your browser to use it as a proxy (the host will be the IP of the SecureCI™ 
system, port `8282`). In Internet Explorer, this is set via ''Tools > Internet Options > Connections > LAN settings > 
Proxy'' server. In Firefox, use ''Tools > Options > Advanced > Network > Connection > Settings''. You can then navigate to 
the web application (running on `192.168.1.10`, in this case) and use the application. When done, use `Ctrl-C` to close 
to proxy. (Remember to turn off the proxy settings in your browser.) Then, generate the report:

{{{
  cd log-directory
  ratproxy-report.sh ratproxy.log > ratproxy.html
  cd ..
  zip ratproxy.zip log-directory/*
}}}

The `ratproxy.zip` file can be transferred to your local system for viewing.

== Certificates ==
Since it is used as a proxy, it will appear to the web application that ratproxy is connecting as the user. As such, 
ratproxy's self-signed certificate will be presented to the web application for HTTPS traffic. Also, the web browser 
will be connecting to ratproxy rather than the web application, and will be presented with ratproxy's certificate on an
HTTPS connection instead of the server's. You may need to make sure that the web application will accept the ratproxy 
certificate as valid. The certificate is stored in `/usr/local/bin/keyfile.pem`. The browser will need to temporarily 
or permanently accept a certificate exception for ratproxy's certificate.

=== More information ===

 * [http://code.google.com/p/ratproxy/wiki/RatproxyDoc ratproxy documentation]

<%= node['trac']['wiki']['footer'] %>